function [y, e, hest, h] = filtrNLMS_rys(M,L,d,x,nr,mi,gamma,alfa,delta,leaky,ialg,ifig)
bx = zeros(1,M);        %  inicjalizacja bufora sygnalu wejsciowego x[n]
h  = zeros(1,M);        %  inicjalizacja wag filtra
coef = 1-mi*leaky;      %  leaky-(N)LMS: wspolczynnik pamietania h, zwiazany z wyciekiem, zwykle 1, jesli leaky=0
y = [];   e = [];       %  wyzerowanie sygnalow wyjsciowych

Rinv = delta*eye(M,M);  %  tylko dla LMS-Newton: inicjalizacja odwrotnosci macierzy autokorelacji sygnalu x[n]
bd = zeros(L,1);        %  tylko dla AP-NLMS: inicjalizacja bufora sygnalu wejsciowego d[n]
X = zeros(L,M);         %  tylko dla AP-NLMS: macierz na probki x[n]

hest = [];              % historia przestrajania wybranych wag filtra 
for n = 1 : length(x)
	
    if(n==1) bxx = eps*ones(1,M); else bxx=bx; end		% zapamietaj poprzednia wartosc
	bx = [ x(n) bx(1:M-1) ];							% pobierz nowa probke x[n] do bufora bx
    
    if(ialg==3)	                                        % TYLKO ALGORYTM AP-NLMS
        X = [ bx; X(1:L-1,1:M) ];                       % pobierz nowy wiersz do macierzy X
        bd = [ d(n); bd(1:L-1) ];						% pobierz nowa probke d[n] do bufora bd
        yL = X*h'; y(n) = yL(1);                        % oblicz yL, y[n]
        eL = bd - yL; e(n)=eL(1);                       % oblicz eL, e[n]
    else		                                        % POZOSTALE ALGORYTMY
		y(n) = h * bx';									% oblicz y[n] = sum( x .* bx)
		e(n) = d(n) - y(n);								% oblicz e[n]
	end

	if (ialg==1)   h = coef*h + mi * e(n) * bx;   end	%   LMS
	if (ialg==2)
		energia = bx * bx';								%   NLMS
		h = coef*h + mi/(gamma+energia) * e(n) * bx;	%   modyfikacja wag
    end
    if (ialg==3)                                             %   AP-NLMS
	    h = coef*h + (mi* X'*inv( X*X'+gamma*eye(L) )*eL)';  %   modyfikacja wag
	end
	if (ialg==4)
   		alfa = (bx*bxx') / (bxx*bxx');                  %  zdekorelowany LMS
		v = bx - alfa*bxx;      						% 
		h = coef*h + mi * e(n) * v;                     %  modyfikacja wag
	end
	if (ialg==5)
		alfa = (bx*bxx') / (bxx*bxx');					% zdekorelowany NLMS
		v = bx - alfa*bxx;								%
	    h = coef*h + mi/(gamma+bx*bx') * e(n) * v;		%  modyfikacja wag
	  % h = coef*h + mi/(gamma+bx*v') * e(n) * v;		%  modyfikacja wag
	end
	if (ialg==6)										                         %  filtr LMS quasi-Newtona
 	  	Rinv = (Rinv - Rinv*bx'*bx*Rinv/((1-alfa)/alfa+bx*Rinv*bx'))/(1-alfa);   %  zmodyfikuj macierz Rinv
	    h = coef*h + mi*(Rinv * bx' * e(n) )';                                   %  modyfikacja wag	
    end
    
    hest = [ hest; h( nr ) ];                        % zapisz wartosci wybranych wag filtra
    
    if(ifig==1)  % rysunki w petli, na zyczenie
       n
       subplot(211); stem(h); title('h[n]'); grid;
       subplot(212); [H, w ] = freqz(h,1,100); stem( w, abs(H)); title('H(w)'); grid; pause
    end   
    
end
