function [y, e] = filtrWRLS2(M,d,x,lambda,delta,ialg)
% Przyklad 7.3
% Autor: Tomasz Zirlinski, tzielin@agh.edu.pl

% INICJOWANIE
if(ialg==0) % start od zera
   bx = zeros(M,1);          % inicjowanie bufora sygnalu wejsciowego x
   h = zeros(M,1);           % inicjowanie wag filtra
   P = delta*eye(M,M);       % inicjowanie odwrotnosci macierzy autokorelacji
                             % sygnalu x[n]; P=R 1
   n1 = 1;                   % indeks startowy petli iteracyjnej
else % start od pierwszej estymaty obliczonej w sposob blokowy
   w = lambda.^(M-1:-1:0); w=w';          % wektor wag
   W = diag(w,0);                         % macierz wag
   X = toeplitz( x(M:2*M-1), x(M:-1:1));  % macierz sygnalu filtrowanego
   d1 = d(M:2*M-1)';                      % wektor sygnalu referencyjnego
   P = pinv(X'*W*X)*X'*W;    % inicjowanie odwrotnosci macierzy autokorelacji
   h = P*d1;                 % inicjowanie wag filtra
   bx = x(2*M-1:-1:M).';     % inicjowanie bufora sygnalu wejsciowego x
   n1 = 2*M;                 % indeks startowy petli iteracyjnej
end
y = []; e = [];                           % wyzerowanie sygnalow wyjsciowych
for n = n1 : length(x)
   bx = [ x(n); bx(1:M-1) ];              % pobierz nowa probke do bufora
   y(n) = h' * bx;                        % oblicz y[n] = sum( x .* bx)
   e(n) = d(n) - y(n);                    % oblicz e[n]
   if(1) % wersja 1 - podobna do LMS Newtona
      P = (P - P*bx*bx'*P/(lambda+bx'*P*bx))/lambda; % zmodyfikuj macierz P = inv(R)
      h = h + P * bx * e(n);              % modyfikacja wag
   else % wersja 2 - ze wzmocnieniem Kalmana [8],[22]
      K = P*bx/(lambda+bx'*P*bx);         % wzmocnienie Kalmana
      h = h + K * e(n);                   % modyfikacja wag
      P = (eye(M)-K*bx')*P/lambda;        % zmodyfikuj macierz P = inv(R)
   end
end