function [y, e, hest, h] = filtrWRLS2_rys(M,d,x,nr,lambda,delta,ialg,ifig) 

% INICJALIZACJA
if(ialg==0)   % start od zera
	bx = zeros(1,M);		%   inicjalizacja bufora sygnalu wejsciowego x
	h = zeros(1,M);			%   inicjalizacja wag filtra
	P = delta*eye(M,M); 	%   inicjalizacja odwrotnosci macierzy autokorelacji sygnalu x[n] 
	n1 = 1;					%   indeks startowy petli iteracyjnej
    hest = [];              %   historia przestrajania wybranych wag filtra 
else        % start od pierwszej estymaty obliczonej w sposob blokowy
	w = lambda.^(M-1:-1:0); w=w';			% wektor wag
	W = diag(w,0); 							% macierz wag
	X = toeplitz( x(M:2*M-1), x(M:-1:1)); 	% macierz sygnalu filtrowanego
	d1 = d(M:2*M-1)';						% wektor sygnalu referencyjnego
	P = pinv(X'*W*X)*X'*W;                  % inicjalizacja odwrotnosci macierzy autokorelacji
	h = (P*d1)';                            % inicjalizacja wag filtra
	bx = x(2*M-1:-1:M);                     % inicjalizacja bufora sygnalu wejsciowego x
	n1 = 2*M;                               % indeks startowy petli iteracyjnej
    hest = meshgrid( h( nr ), 1:2*M-1  );   % historia przestrajania wybranych wag filtra 
end

y = [];   e = [];				% wyzerowanie sygnalow wyjsciowych
for n = n1 : length(x) 
	bx = [ x(n) bx(1:M-1) ];	% pobierz nowa probke do bufora
	y(n) = h * bx';				% oblicz y[n] = sum( x .* bx) 
	e(n) = d(n) - y(n);			% oblicz e[n] 
	if(1)     % wersja 1 - podobna do LMS Netona
		P = (P - P*bx'*bx*P/(lambda+bx*P*bx'))/lambda;	%  zmodyfikuj macierz P = inv(R) 
		h = h + (P * bx' * e(n) )';						%  modyfikacja wag
	else     % wersja 2 ze wzmocnieniem Kalmana [Host97],[Ziel05] 
		K = P*bx'/(lambda+bx*P*bx');					%  wzmocnienie Kalmana
		h = h + K' * e(n); 								%  modyfikacja wag
		P = (eye(M)-K*bx)*P/lambda;						%  zmodyfikuj macierz P = inv(R)
    end    
    hest = [ hest; h( nr ) ];   % zapisz wartosci wybranych wag filtra
    
    if(ifig==1)  % rysunki w petli, na zyczenie
       n
       subplot(211); stem(h); title('h[n]'); grid;
       subplot(212); [H, w ] = freqz(h,1,100); stem( w, abs(H)); title('H(w)'); grid; pause
    end
    
end
